#include "list.h"

class Ban;
class Userchaninfo;
class User;
class Channel;

class Ban {
public:
	Userchaninfo *banned;
	Userchaninfo *banner;
	time_t t;
	time_t expires;
	int level;
	Ban(Userchaninfo*, Userchaninfo*, int);
	~Ban();
};


class Userchaninfo {
public:
	Channel *channel;
	User *user;
	List<Ban*> banner;
	List<Ban*> banned;
	int banlevel;
	time_t lastjoin;
	time_t lastleave;
	time_t lastspoke;
	~Userchaninfo();
	Userchaninfo(User *_user, Channel *_channel);
	Ban *findban(Userchaninfo *banuci);
	void removebanned(Ban *ban);
	void removebanner(Ban *ban);
};

#pragma warning(disable:4284)

class User {
public:
	List<char*> names;
	List<long> accounts;
	List<Userchaninfo*> channelinfos;
	enum {CHAT, DRTL, STAR, OTHER} type;
	User(char *name);
	~User();
	int ban(Channel *channel, User *banuser);
	int unban(Channel *channel, User *banuser);
	void removechaninfo(Userchaninfo *uci);
	void settype(char *stats);
	void removebans(Channel *channel);
	Userchaninfo *uci(Channel *channel);
	static User *find(char *_name);
	static List<User*> users;
};

class Channel {
public:
	char *name;
	List<User*> members;
	Channel(char *_name);
	~Channel();
	static Channel *find(char *_name);
	static List<Channel*> channels;
	void join(User *user);
	void leave(User *user);
	int ismember(User *user);
};
